/* Generated by Edge Impulse
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
// Generated on: 16.06.2023 18:40:59

#include <stdio.h>
#include <stdlib.h>
#include "edge-impulse-sdk/tensorflow/lite/c/builtin_op_data.h"
#include "edge-impulse-sdk/tensorflow/lite/c/common.h"
#include "edge-impulse-sdk/tensorflow/lite/micro/micro_mutable_op_resolver.h"
#include "edge-impulse-sdk/porting/ei_classifier_porting.h"

#if EI_CLASSIFIER_PRINT_STATE
#if defined(__cplusplus) && EI_C_LINKAGE == 1
extern "C" {
    extern void ei_printf(const char *format, ...);
}
#else
extern void ei_printf(const char *format, ...);
#endif
#endif

#if defined __GNUC__
#define ALIGN(X) __attribute__((aligned(X)))
#elif defined _MSC_VER
#define ALIGN(X) __declspec(align(X))
#elif defined __TASKING__
#define ALIGN(X) __align(X)
#endif

#ifndef EI_MAX_SCRATCH_BUFFER_COUNT
#define EI_MAX_SCRATCH_BUFFER_COUNT 4
#endif // EI_MAX_SCRATCH_BUFFER_COUNT

#ifndef EI_MAX_OVERFLOW_BUFFER_COUNT
#define EI_MAX_OVERFLOW_BUFFER_COUNT 10
#endif // EI_MAX_OVERFLOW_BUFFER_COUNT

using namespace tflite;
using namespace tflite::ops;
using namespace tflite::ops::micro;

namespace {

#if defined(EI_CLASSIFIER_ALLOCATION_STATIC_HIMAX) || defined(EI_CLASSIFIER_ALLOCATION_STATIC_HIMAX_GNU)
constexpr int kTensorArenaSize = 10192;
#else
constexpr int kTensorArenaSize = 9168;
#endif

#if defined(EI_CLASSIFIER_ALLOCATION_STATIC)
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16);
#elif defined(EI_CLASSIFIER_ALLOCATION_STATIC_HIMAX)
#pragma Bss(".tensor_arena")
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16);
#pragma Bss()
#elif defined(EI_CLASSIFIER_ALLOCATION_STATIC_HIMAX_GNU)
uint8_t tensor_arena[kTensorArenaSize] ALIGN(16) __attribute__((section(".tensor_arena")));
#else
#define EI_CLASSIFIER_ALLOCATION_HEAP 1
uint8_t* tensor_arena = NULL;
#endif

static uint8_t* tensor_boundary;
static uint8_t* current_location;

template <int SZ, class T> struct TfArray {
  int sz; T elem[SZ];
};
enum used_operators_e {
  OP_RESHAPE, OP_CONV_2D, OP_MAX_POOL_2D, OP_FULLY_CONNECTED, OP_SOFTMAX,  OP_LAST
};
struct TensorInfo_t { // subset of TfLiteTensor used for initialization from constant memory
  TfLiteAllocationType allocation_type;
  TfLiteType type;
  void* data;
  TfLiteIntArray* dims;
  size_t bytes;
  TfLiteQuantization quantization;
};
struct NodeInfo_t { // subset of TfLiteNode used for initialization from constant memory
  struct TfLiteIntArray* inputs;
  struct TfLiteIntArray* outputs;
  void* builtin_data;
  used_operators_e used_op_index;
};

typedef struct {
  TfLiteTensor tensor;
  int16_t index;
} TfLiteTensorWithIndex;

typedef struct {
  TfLiteEvalTensor tensor;
  int16_t index;
} TfLiteEvalTensorWithIndex;

TfLiteContext ctx{};
static const int MAX_TFL_TENSOR_COUNT = 4;
static TfLiteTensorWithIndex tflTensors[MAX_TFL_TENSOR_COUNT];
static const int MAX_TFL_EVAL_COUNT = 4;
static TfLiteEvalTensorWithIndex tflEvalTensors[MAX_TFL_EVAL_COUNT];
TfLiteRegistration registrations[OP_LAST];
TfLiteNode tflNodes[11];

const TfArray<2, int> tensor_dimension0 = { 2, { 1,4018 } };
const TfArray<1, float> quant0_scale = { 1, { 0.0036611519753932953, } };
const TfArray<1, int> quant0_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant0 = { (TfLiteFloatArray*)&quant0_scale, (TfLiteIntArray*)&quant0_zero, 0 };
const ALIGN(16) int32_t tensor_data1[4] = { 1, 1, 98, 41, };
const TfArray<1, int> tensor_dimension1 = { 1, { 4 } };
const ALIGN(16) int32_t tensor_data2[4] = { 1, 98, 1, 8, };
const TfArray<1, int> tensor_dimension2 = { 1, { 4 } };
const ALIGN(16) int32_t tensor_data3[4] = { 1, 1, 49, 8, };
const TfArray<1, int> tensor_dimension3 = { 1, { 4 } };
const ALIGN(16) int32_t tensor_data4[4] = { 1, 49, 1, 16, };
const TfArray<1, int> tensor_dimension4 = { 1, { 4 } };
const ALIGN(8) int32_t tensor_data5[2] = { -1, 400, };
const TfArray<1, int> tensor_dimension5 = { 1, { 2 } };
const ALIGN(16) int8_t tensor_data6[8*1*3*41] = { 
  /* [0][0][][] */ -83,34,-84,63,76,-68,41,67,70,-64,-19,70,-5,100,-36,-95,-36,-12,-44,-57,-103,33,-27,21,90,88,-124,-9,-10,-69,-90,-6,-78,-37,79,32,-127,-87,-19,-122,88, 20,78,-50,-7,76,81,-94,21,-24,97,-14,-53,-58,-36,91,-33,-64,11,-33,-79,-62,56,-65,-27,-116,-110,-38,32,20,-57,75,97,-15,-61,-85,-54,-6,-74,-51,7,-63, -25,48,79,19,63,13,-57,-77,-72,-32,-25,43,-27,17,-110,-103,-72,89,62,42,15,-106,10,59,-93,-78,-44,71,-106,-46,35,-20,-62,-39,73,42,70,-62,-65,-93,93, 
  /* [1][0][][] */ -8,-28,-70,-84,4,-20,-12,-126,-41,50,0,-118,74,18,-49,47,-31,-4,14,-44,-111,32,-85,-113,59,36,-19,-13,-90,73,-45,-75,0,-74,-68,-84,-14,-40,-3,1,-63, 7,-17,17,-80,54,67,-79,70,66,-30,46,-122,-123,-62,-108,-30,39,-57,-65,13,60,73,28,65,5,-59,-99,-65,-3,-80,72,42,14,-71,65,-107,42,81,88,-127,-26, -3,76,30,-122,-39,-120,46,31,-57,-34,76,7,-86,54,-27,-111,-81,-122,-77,-99,-107,5,-29,0,34,-104,37,-53,-112,9,81,46,-14,6,50,45,44,-30,-42,-57,-10, 
  /* [2][0][][] */ -15,-103,-91,87,-127,-106,-125,75,-57,-71,-17,93,51,17,-54,-121,20,-19,-41,57,-83,4,-43,45,-53,-51,-7,-110,-99,-33,-97,10,73,-91,-42,49,-27,-61,16,-29,-89, -86,-59,39,-66,79,-51,-110,-53,-81,62,-76,55,-30,32,-69,56,-49,-97,26,-65,-61,-86,-13,-10,-2,-96,70,5,-27,-30,25,9,-42,-4,-85,97,50,-44,-14,-110,-116, 83,-19,64,-86,89,38,-58,-119,16,-51,38,68,0,-66,-83,15,-55,-49,81,-56,-50,-7,-100,-15,80,22,-71,-111,-38,27,97,-15,-12,69,11,-96,86,-120,103,-57,49, 
  /* [3][0][][] */ 15,76,2,71,100,40,39,71,-15,11,6,-42,-10,58,66,-65,-28,20,-89,-62,-12,24,45,-62,30,15,4,-2,-14,73,-41,-67,-9,-18,80,110,-47,72,58,-50,30, 62,3,-63,21,69,122,51,25,50,-55,22,-68,-62,-14,75,-41,-6,2,-84,-52,-9,-6,-77,-43,-12,23,25,28,34,76,-88,-127,23,0,90,54,-67,68,19,-13,2, 126,-24,-4,-14,59,83,59,11,20,38,31,-47,-10,-58,31,-33,-61,36,-78,-82,-56,-63,-55,-69,-97,47,-30,8,-25,-21,-91,-42,21,35,28,83,23,62,88,-24,5, 
  /* [4][0][][] */ -14,29,-93,34,84,-83,6,0,-121,6,22,73,-4,38,-14,-100,18,-95,-35,-67,11,-27,4,-103,22,24,-23,-71,92,-107,-22,-96,87,-58,-115,-110,87,98,-84,41,-69, 36,-50,-35,41,12,-123,-87,-21,-33,-2,-127,-124,-47,-117,-57,88,-96,-74,72,-25,-106,-78,87,29,84,-98,30,5,-8,88,73,-61,-21,86,-13,55,-114,23,-41,-76,-50, 77,22,55,-81,-122,-63,14,10,43,-80,55,-9,-53,-99,-100,-26,14,31,33,-39,99,-106,96,-89,5,43,60,-105,-127,-26,12,-15,16,74,52,33,35,60,40,-37,-2, 
  /* [5][0][][] */ 46,1,11,8,-12,-37,-47,-57,37,-110,-22,-6,82,-27,-69,3,36,71,-60,59,-20,15,53,-39,-10,-73,86,-77,-54,29,84,36,-109,-21,-51,63,-13,-61,-65,-48,-72, -82,-104,80,-32,50,8,27,-110,65,-77,-127,-79,-91,-53,-44,23,-84,75,-107,-92,-125,-78,-98,-31,0,42,34,-93,82,42,78,-10,47,41,33,-125,83,16,2,-11,16, -34,-97,7,-47,51,72,70,-124,-33,74,39,61,-1,85,46,-70,56,2,-22,-52,3,-63,46,75,54,-15,44,60,-56,-82,-118,-102,84,-117,-77,-22,-29,77,-35,-18,-76, 
  /* [6][0][][] */ -100,-83,-126,-109,-40,-31,94,30,-100,81,-60,36,8,-54,26,16,40,-43,-20,-92,-68,-6,-5,59,-44,-109,-110,-44,78,-91,-127,-108,-41,77,-27,80,-5,-109,-98,61,-39, -77,-43,51,-35,13,-64,-124,-29,-36,4,7,-33,-11,-114,86,-81,5,-117,92,11,46,76,19,-110,-72,-100,-74,45,-47,11,-64,-84,-109,-24,32,0,66,-37,25,-87,63, 28,-18,-5,-56,73,20,25,55,9,11,-32,-3,-30,-6,-98,-86,-27,51,71,-17,-37,-12,-126,-113,61,-26,80,-61,-33,-58,-5,55,70,65,53,-45,51,34,42,61,-104, 
  /* [7][0][][] */ -55,-85,-47,39,30,-91,-52,25,-37,33,-107,-46,12,85,-22,-2,-82,-2,58,-108,70,-30,76,84,81,50,-79,-108,72,64,-93,-59,32,-88,-48,-77,88,-69,29,18,-19, -30,-43,42,-118,-14,47,43,58,-34,-51,5,-87,-62,40,-122,8,-27,6,-111,-33,-63,83,-90,83,58,48,-52,69,83,21,-7,3,49,-121,-111,-117,61,25,-93,-111,-111, -112,-63,33,-11,45,57,-105,-9,-127,-49,-44,29,-72,23,-26,-16,-66,-45,-7,71,-37,-50,-63,48,65,38,-116,22,-89,-62,-86,-31,-3,28,-119,-101,-21,57,3,-58,45, 
};
const TfArray<4, int> tensor_dimension6 = { 4, { 8,1,3,41 } };
const TfArray<8, float> quant6_scale = { 8, { 0.0017815232276916504, 0.0018347072182223201, 0.0017671629320830107, 0.0036012006457895041, 0.001763183856382966, 0.0018266864353790879, 0.0017935024807229638, 0.0018758740043267608, } };
const TfArray<8, int> quant6_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant6 = { (TfLiteFloatArray*)&quant6_scale, (TfLiteIntArray*)&quant6_zero, 0 };
const ALIGN(16) int32_t tensor_data7[8] = { -3922, -3445, -2841, -18278, -1175, -4401, -4516, -3898, };
const TfArray<1, int> tensor_dimension7 = { 1, { 8 } };
const TfArray<8, float> quant7_scale = { 8, { 6.5224271565966774e-06, 6.7171417867939454e-06, 6.4698519963712897e-06, 1.3184542694943957e-05, 6.4552841649856418e-06, 6.6877764766104519e-06, 6.5662852648529224e-06, 6.8678596107929479e-06, } };
const TfArray<8, int> quant7_zero = { 8, { 0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant7 = { (TfLiteFloatArray*)&quant7_scale, (TfLiteIntArray*)&quant7_zero, 0 };
const ALIGN(16) int8_t tensor_data8[16*1*3*8] = { 
  /* [0][0][][] */ -47,-16,-29,127,-26,-75,61,-43, 73,-21,-79,53,-31,-79,24,-36, 55,-60,61,122,14,72,50,12, 
  /* [1][0][][] */ -35,41,-46,-35,-3,-24,29,21, -42,-33,-25,99,-40,16,-14,-7, 36,40,22,127,32,-13,-41,15, 
  /* [2][0][][] */ -38,27,-33,-19,6,37,-41,-42, 40,-8,-7,127,8,-28,-42,32, -14,-43,-21,16,2,7,16,-2, 
  /* [3][0][][] */ -36,18,13,29,-16,42,-12,43, -18,-21,18,127,40,43,39,-16, 4,-60,36,49,-18,27,37,-32, 
  /* [4][0][][] */ 9,12,49,55,24,-38,-23,30, -58,-16,6,-33,-34,-49,12,44, 48,-56,41,127,-39,44,-45,55, 
  /* [5][0][][] */ 47,-33,-79,127,62,72,5,61, -50,-56,-60,125,34,65,-51,-50, -23,13,38,-46,44,4,-62,44, 
  /* [6][0][][] */ 43,17,25,127,4,25,-25,33, 20,-2,21,-45,6,53,-5,-66, -28,41,-2,33,41,-31,-1,-17, 
  /* [7][0][][] */ -23,-29,40,-27,-17,38,42,8, 22,-40,-27,127,43,16,25,-53, -44,-35,-30,54,26,15,-17,30, 
  /* [8][0][][] */ -52,-43,57,-105,-35,-16,16,67, -7,-28,-57,-5,61,24,37,46, 3,-64,41,-127,-23,-54,60,23, 
  /* [9][0][][] */ -5,-13,4,-8,15,11,-20,-6, -1,15,16,-127,5,5,15,-10, -13,0,17,-71,3,-6,6,4, 
  /* [10][0][][] */ -1,0,10,27,-3,-19,-11,8, 19,2,3,36,17,5,16,-13, 1,-2,-2,-127,-10,-8,16,-4, 
  /* [11][0][][] */ 10,-30,-10,85,-16,-48,50,-1, -17,59,53,-17,-36,-5,18,67, 31,26,-57,127,60,-54,62,15, 
  /* [12][0][][] */ 72,-2,-103,-127,43,72,35,-83, -29,-22,102,-76,54,-91,53,58, 1,28,-55,-122,-25,55,-6,83, 
  /* [13][0][][] */ -15,28,-56,127,-58,-56,-6,-49, -63,-22,30,19,55,11,-74,-46, -21,-67,-41,102,0,46,70,-19, 
  /* [14][0][][] */ 5,19,61,127,-72,84,-38,-84, 26,47,-75,124,71,-5,6,-49, -41,77,50,-40,-8,44,15,-11, 
  /* [15][0][][] */ 38,16,-10,127,-26,-51,-31,-16, -11,15,-4,-55,35,29,50,-4, 33,-27,20,-40,-19,12,-25,6, 
};
const TfArray<4, int> tensor_dimension8 = { 4, { 16,1,3,8 } };
const TfArray<16, float> quant8_scale = { 16, { 0.0033766056876629591, 0.0052256118506193161, 0.0056490520946681499, 0.004819781519472599, 0.0048308782279491425, 0.0035854740999639034, 0.0051395967602729797, 0.005826377309858799, 0.0036280488129705191, 0.015399961732327938, 0.014865088276565075, 0.0041357604786753654, 0.0026775375008583069, 0.0033923638984560966, 0.0033319469075649977, 0.0059125307016074657, } };
const TfArray<16, int> quant8_zero = { 16, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant8 = { (TfLiteFloatArray*)&quant8_scale, (TfLiteIntArray*)&quant8_zero, 0 };
const ALIGN(16) int32_t tensor_data9[16] = { -9189, -11118, -4534, -9504, -11438, -9051, -4725, -12233, 13032, 4892, -1581, -7207, 17218, -7851, -11264, -2280, };
const TfArray<1, int> tensor_dimension9 = { 1, { 16 } };
const TfArray<16, float> quant9_scale = { 16, { 1.0707683031796478e-05, 1.6571137166465633e-05, 1.7913924239110202e-05, 1.5284193068509921e-05, 1.5319381418521516e-05, 1.1370033462299034e-05, 1.6298370610456914e-05, 1.8476246623322368e-05, 1.1505043403303716e-05, 4.8835405323188752e-05, 4.7139244998106733e-05, 1.3115067304170225e-05, 8.4908406279282644e-06, 1.075765430869069e-05, 1.0566063792794012e-05, 1.8749451555777341e-05, } };
const TfArray<16, int> quant9_zero = { 16, { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 } };
const TfLiteAffineQuantization quant9 = { (TfLiteFloatArray*)&quant9_scale, (TfLiteIntArray*)&quant9_zero, 0 };
const ALIGN(16) int8_t tensor_data10[2*400] = { 
  47, 37, 40, 32, 24, 37, 51, 41, -13, -24, 40, 60, -17, 52, 72, 4, 31, 26, 42, 3, -9, 18, 21, 21, -27, -63, 57, 15, -26, 31, 23, 60, 38, 31, -12, -26, 33, -19, 32, 13, -29, -28, 14, 32, -24, 23, 3, 75, 34, -1, 42, 16, -11, 13, 34, -1, -13, -37, 57, 32, -29, 28, 28, 54, -4, -3, 14, -10, 13, -18, -1, -4, -10, -15, -16, 1, -18, 13, -25, -15, -9, -13, 39, 14, -13, 16, 21, 6, -18, -11, 20, -8, -23, 8, 24, -8, 4, -2, -60, -39, 15, -39, -12, -33, -9, -5, -43, 9, -8, 3, -32, -39, 16, 4, 21, 22, -17, 1, 2, -3, -6, -7, 13, 11, -16, 0, 25, 8, 12, -4, -41, -5, 15, -11, 9, -5, -5, -11, 33, 17, -11, 17, -22, 11, 2, 2, 34, 28, 17, 8, 5, 0, -2, 1, 33, 24, -14, 8, 23, -4, 16, 28, 59, 43, -11, 31, 6, 26, -23, -26, 79, 12, -17, 4, 47, 13, 33, 14, 26, 14, 2, -11, 23, -13, -23, 3, -27, 27, -12, 15, -11, 13, -6, -2, 34, 33, 2, 21, 18, -3, -1, -8, 30, 2, -21, 6, 20, 15, 15, 9, 5, -6, -3, -9, -2, -2, -19, -3, 19, 3, -10, 15, -4, 18, 10, -14, 47, 28, 2, 37, 16, -4, -12, 5, 24, -3, -8, 3, 26, 33, 15, -9, 0, 2, 4, -2, -22, -23, -15, 1, 15, 6, -10, 15, 2, -38, 33, 8, 19, 26, 6, 17, 26, -13, -15, -9, 21, 14, -16, 9, 32, 13, 13, 18, 6, 14, 4, 2, 17, 11, -15, 0, 37, 8, -8, 6, 7, -19, 2, -37, -35, -10, -34, -1, 14, -33, -13, 3, -26, -3, -6, -10, 2, 27, -15, 8, -22, -6, -13, -12, -34, -16, -17, 4, 7, 12, -1, 3, -45, -92, 11, 7, 9, -8, -15, -2, 14, -1, -8, -14, 39, 24, -21, 24, 0, 21, 17, 16, 9, 26, 4, 2, -8, 2, -15, -3, 51, 34, -6, 12, -6, -22, 41, 22, 44, 36, 20, 15, 43, 1, -17, 21, 86, 48, -13, 34, 20, 6, 54, 28, 54, 35, 75, 15, 49, 6, -7, 2, 107, 35, -15, 22, 45, 33, 55, 116, 21, 37, 23, 40, 43, 42, 4, 123, 25, 25, 10, 52, 48, 62, 
  -44, -58, -42, -33, -14, -38, -41, -35, 15, 28, -39, -57, 17, -51, -76, -16, -23, -34, -29, -1, 4, -14, -28, -24, 11, 56, -37, -23, 28, -25, -19, -46, -39, -29, 14, 16, -32, 7, -24, -17, 17, 36, -9, -18, 18, -34, 5, -70, -25, 2, -35, -6, 12, -13, -38, 12, 20, 22, -45, -33, 29, -45, -26, -47, -2, 9, -18, -12, -14, 8, 10, 12, 9, -3, 7, 0, 12, -7, 16, 11, -1, 17, -26, -23, 6, -23, -7, -12, 8, -5, -21, -8, 19, -3, -22, 9, 3, 15, 79, 42, -16, 39, 28, 32, 20, 8, 42, -7, -6, -8, 35, 39, -11, -11, -19, -23, 9, -18, -2, 9, 15, 8, -10, -1, 12, -6, -19, -10, -14, 3, 44, 16, -9, 5, -11, 12, 23, 11, -20, -11, 10, -4, 23, -11, 0, -13, -25, -13, -7, -12, -6, -7, 14, 4, -21, -20, 20, -12, -15, -12, -17, -19, -46, -36, 17, -35, -7, -13, 4, 12, -67, -18, -1, 4, -29, -23, -23, -4, -25, -5, -19, 6, -11, 14, 3, 13, 28, -19, 10, -11, 4, -13, 6, 3, -43, -45, 13, -28, -16, -1, 16, 1, -26, 5, 26, -5, -19, -5, 0, -18, 6, 3, -2, -2, 4, 4, 1, 8, -24, -10, 16, -18, -3, -18, -3, 13, -38, -18, 17, -23, -12, -4, 14, 9, -26, -3, 11, -21, -13, -21, -26, 12, 7, 11, -14, 3, 8, 22, 15, 14, -9, -17, 11, -13, 2, 33, -15, -5, -3, -19, -11, 4, -15, 8, 7, 11, -40, -20, 18, -17, -20, -12, -10, -18, -23, -17, -21, -4, -6, -10, 0, -4, -31, -14, 4, -15, -6, 16, 2, 36, 40, 13, 19, -7, -23, 38, 1, 1, 48, 7, 8, -5, -4, -10, -2, -2, 20, -7, 7, 7, 53, 9, 12, -14, 2, -14, 20, -2, 24, 95, -17, 14, -13, 3, 21, 3, -28, 12, -2, 7, -43, -33, 20, -9, -15, -24, -19, -27, -14, -14, -12, 7, 5, 8, 8, -9, -38, -12, 6, -28, -4, 19, -26, -4, -37, -49, -26, -15, -49, -2, 12, -19, -75, -39, 1, -28, -10, -6, -38, -49, -56, -41, -77, -18, -45, -7, 11, -12, -109, -33, 17, -37, -27, -27, -53, -115, -12, -35, -18, -24, -43, -45, 14, -127, -21, -13, 9, -47, -45, -48, 
};
const TfArray<2, int> tensor_dimension10 = { 2, { 2,400 } };
const TfArray<1, float> quant10_scale = { 1, { 0.010739515535533428, } };
const TfArray<1, int> quant10_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant10 = { (TfLiteFloatArray*)&quant10_scale, (TfLiteIntArray*)&quant10_zero, 0 };
const ALIGN(8) int32_t tensor_data11[2] = { -11748, 11748, };
const TfArray<1, int> tensor_dimension11 = { 1, { 2 } };
const TfArray<1, float> quant11_scale = { 1, { 2.6531575713306665e-05, } };
const TfArray<1, int> quant11_zero = { 1, { 0 } };
const TfLiteAffineQuantization quant11 = { (TfLiteFloatArray*)&quant11_scale, (TfLiteIntArray*)&quant11_zero, 0 };
const TfArray<4, int> tensor_dimension12 = { 4, { 1,1,98,41 } };
const TfArray<1, float> quant12_scale = { 1, { 0.0036611519753932953, } };
const TfArray<1, int> quant12_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant12 = { (TfLiteFloatArray*)&quant12_scale, (TfLiteIntArray*)&quant12_zero, 0 };
const TfArray<4, int> tensor_dimension13 = { 4, { 1,1,98,8 } };
const TfArray<1, float> quant13_scale = { 1, { 0.0031711379997432232, } };
const TfArray<1, int> quant13_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant13 = { (TfLiteFloatArray*)&quant13_scale, (TfLiteIntArray*)&quant13_zero, 0 };
const TfArray<4, int> tensor_dimension14 = { 4, { 1,98,1,8 } };
const TfArray<1, float> quant14_scale = { 1, { 0.0031711379997432232, } };
const TfArray<1, int> quant14_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant14 = { (TfLiteFloatArray*)&quant14_scale, (TfLiteIntArray*)&quant14_zero, 0 };
const TfArray<4, int> tensor_dimension15 = { 4, { 1,49,1,8 } };
const TfArray<1, float> quant15_scale = { 1, { 0.0031711379997432232, } };
const TfArray<1, int> quant15_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant15 = { (TfLiteFloatArray*)&quant15_scale, (TfLiteIntArray*)&quant15_zero, 0 };
const TfArray<4, int> tensor_dimension16 = { 4, { 1,1,49,8 } };
const TfArray<1, float> quant16_scale = { 1, { 0.0031711379997432232, } };
const TfArray<1, int> quant16_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant16 = { (TfLiteFloatArray*)&quant16_scale, (TfLiteIntArray*)&quant16_zero, 0 };
const TfArray<4, int> tensor_dimension17 = { 4, { 1,1,49,16 } };
const TfArray<1, float> quant17_scale = { 1, { 0.0024704630486667156, } };
const TfArray<1, int> quant17_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant17 = { (TfLiteFloatArray*)&quant17_scale, (TfLiteIntArray*)&quant17_zero, 0 };
const TfArray<4, int> tensor_dimension18 = { 4, { 1,49,1,16 } };
const TfArray<1, float> quant18_scale = { 1, { 0.0024704630486667156, } };
const TfArray<1, int> quant18_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant18 = { (TfLiteFloatArray*)&quant18_scale, (TfLiteIntArray*)&quant18_zero, 0 };
const TfArray<4, int> tensor_dimension19 = { 4, { 1,25,1,16 } };
const TfArray<1, float> quant19_scale = { 1, { 0.0024704630486667156, } };
const TfArray<1, int> quant19_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant19 = { (TfLiteFloatArray*)&quant19_scale, (TfLiteIntArray*)&quant19_zero, 0 };
const TfArray<2, int> tensor_dimension20 = { 2, { 1,400 } };
const TfArray<1, float> quant20_scale = { 1, { 0.0024704630486667156, } };
const TfArray<1, int> quant20_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant20 = { (TfLiteFloatArray*)&quant20_scale, (TfLiteIntArray*)&quant20_zero, 0 };
const TfArray<2, int> tensor_dimension21 = { 2, { 1,2 } };
const TfArray<1, float> quant21_scale = { 1, { 0.079414620995521545, } };
const TfArray<1, int> quant21_zero = { 1, { -5 } };
const TfLiteAffineQuantization quant21 = { (TfLiteFloatArray*)&quant21_scale, (TfLiteIntArray*)&quant21_zero, 0 };
const TfArray<2, int> tensor_dimension22 = { 2, { 1,2 } };
const TfArray<1, float> quant22_scale = { 1, { 0.00390625, } };
const TfArray<1, int> quant22_zero = { 1, { -128 } };
const TfLiteAffineQuantization quant22 = { (TfLiteFloatArray*)&quant22_scale, (TfLiteIntArray*)&quant22_zero, 0 };
const TfLiteReshapeParams opdata0 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs0 = { 2, { 0,1 } };
const TfArray<1, int> outputs0 = { 1, { 12 } };
const TfLiteConvParams opdata1 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu, 1,1 };
const TfArray<3, int> inputs1 = { 3, { 12,6,7 } };
const TfArray<1, int> outputs1 = { 1, { 13 } };
const TfLiteReshapeParams opdata2 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs2 = { 2, { 13,2 } };
const TfArray<1, int> outputs2 = { 1, { 14 } };
const TfLitePoolParams opdata3 = { kTfLitePaddingSame, 1,2, 1,2, kTfLiteActNone, { { 0,0, 0, 0 } } };
const TfArray<1, int> inputs3 = { 1, { 14 } };
const TfArray<1, int> outputs3 = { 1, { 15 } };
const TfLiteReshapeParams opdata4 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs4 = { 2, { 15,3 } };
const TfArray<1, int> outputs4 = { 1, { 16 } };
const TfLiteConvParams opdata5 = { kTfLitePaddingSame, 1,1, kTfLiteActRelu, 1,1 };
const TfArray<3, int> inputs5 = { 3, { 16,8,9 } };
const TfArray<1, int> outputs5 = { 1, { 17 } };
const TfLiteReshapeParams opdata6 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs6 = { 2, { 17,4 } };
const TfArray<1, int> outputs6 = { 1, { 18 } };
const TfLitePoolParams opdata7 = { kTfLitePaddingSame, 1,2, 1,2, kTfLiteActNone, { { 0,0, 0, 0 } } };
const TfArray<1, int> inputs7 = { 1, { 18 } };
const TfArray<1, int> outputs7 = { 1, { 19 } };
const TfLiteReshapeParams opdata8 = { { 0, 0, 0, 0, 0, 0, 0, 0, }, 0 };
const TfArray<2, int> inputs8 = { 2, { 19,5 } };
const TfArray<1, int> outputs8 = { 1, { 20 } };
const TfLiteFullyConnectedParams opdata9 = { kTfLiteActNone, kTfLiteFullyConnectedWeightsFormatDefault, false, false };
const TfArray<3, int> inputs9 = { 3, { 20,10,11 } };
const TfArray<1, int> outputs9 = { 1, { 21 } };
const TfLiteSoftmaxParams opdata10 = { 1 };
const TfArray<1, int> inputs10 = { 1, { 21 } };
const TfArray<1, int> outputs10 = { 1, { 22 } };
const TensorInfo_t tensorData[] = {
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 4032, (TfLiteIntArray*)&tensor_dimension0, 4018, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant0))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data1, (TfLiteIntArray*)&tensor_dimension1, 16, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data2, (TfLiteIntArray*)&tensor_dimension2, 16, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data3, (TfLiteIntArray*)&tensor_dimension3, 16, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data4, (TfLiteIntArray*)&tensor_dimension4, 16, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data5, (TfLiteIntArray*)&tensor_dimension5, 8, {kTfLiteNoQuantization, nullptr}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data6, (TfLiteIntArray*)&tensor_dimension6, 984, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant6))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data7, (TfLiteIntArray*)&tensor_dimension7, 32, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant7))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data8, (TfLiteIntArray*)&tensor_dimension8, 384, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant8))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data9, (TfLiteIntArray*)&tensor_dimension9, 64, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant9))}, },
  { kTfLiteMmapRo, kTfLiteInt8, (void*)tensor_data10, (TfLiteIntArray*)&tensor_dimension10, 800, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant10))}, },
  { kTfLiteMmapRo, kTfLiteInt32, (void*)tensor_data11, (TfLiteIntArray*)&tensor_dimension11, 8, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant11))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension12, 4018, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant12))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 4032, (TfLiteIntArray*)&tensor_dimension13, 784, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant13))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension14, 784, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant14))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 784, (TfLiteIntArray*)&tensor_dimension15, 392, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant15))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension16, 392, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant16))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 784, (TfLiteIntArray*)&tensor_dimension17, 784, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant17))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension18, 784, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant18))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 784, (TfLiteIntArray*)&tensor_dimension19, 400, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant19))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension20, 400, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant20))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 400, (TfLiteIntArray*)&tensor_dimension21, 2, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant21))}, },
  { kTfLiteArenaRw, kTfLiteInt8, tensor_arena + 0, (TfLiteIntArray*)&tensor_dimension22, 2, {kTfLiteAffineQuantization, const_cast<void*>(static_cast<const void*>(&quant22))}, },
};const NodeInfo_t nodeData[] = {
  { (TfLiteIntArray*)&inputs0, (TfLiteIntArray*)&outputs0, const_cast<void*>(static_cast<const void*>(&opdata0)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs1, (TfLiteIntArray*)&outputs1, const_cast<void*>(static_cast<const void*>(&opdata1)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs2, (TfLiteIntArray*)&outputs2, const_cast<void*>(static_cast<const void*>(&opdata2)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs3, (TfLiteIntArray*)&outputs3, const_cast<void*>(static_cast<const void*>(&opdata3)), OP_MAX_POOL_2D, },
  { (TfLiteIntArray*)&inputs4, (TfLiteIntArray*)&outputs4, const_cast<void*>(static_cast<const void*>(&opdata4)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs5, (TfLiteIntArray*)&outputs5, const_cast<void*>(static_cast<const void*>(&opdata5)), OP_CONV_2D, },
  { (TfLiteIntArray*)&inputs6, (TfLiteIntArray*)&outputs6, const_cast<void*>(static_cast<const void*>(&opdata6)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs7, (TfLiteIntArray*)&outputs7, const_cast<void*>(static_cast<const void*>(&opdata7)), OP_MAX_POOL_2D, },
  { (TfLiteIntArray*)&inputs8, (TfLiteIntArray*)&outputs8, const_cast<void*>(static_cast<const void*>(&opdata8)), OP_RESHAPE, },
  { (TfLiteIntArray*)&inputs9, (TfLiteIntArray*)&outputs9, const_cast<void*>(static_cast<const void*>(&opdata9)), OP_FULLY_CONNECTED, },
  { (TfLiteIntArray*)&inputs10, (TfLiteIntArray*)&outputs10, const_cast<void*>(static_cast<const void*>(&opdata10)), OP_SOFTMAX, },
};

static void init_tflite_tensor(size_t i, TfLiteTensor *tensor) {
  tensor->type = tensorData[i].type;
  tensor->is_variable = 0;

#if defined(EI_CLASSIFIER_ALLOCATION_HEAP)
  tensor->allocation_type = tensorData[i].allocation_type;
#else
  tensor->allocation_type = (tensor_arena <= tensorData[i].data && tensorData[i].data < tensor_arena + kTensorArenaSize) ? kTfLiteArenaRw : kTfLiteMmapRo;
#endif
  tensor->bytes = tensorData[i].bytes;
  tensor->dims = tensorData[i].dims;

#if defined(EI_CLASSIFIER_ALLOCATION_HEAP)
  if(tensor->allocation_type == kTfLiteArenaRw){
    uint8_t* start = (uint8_t*) ((uintptr_t)tensorData[i].data + (uintptr_t) tensor_arena);

    tensor->data.data =  start;
  }
  else {
      tensor->data.data = tensorData[i].data;
  }
#else
  tensor->data.data = tensorData[i].data;
#endif // EI_CLASSIFIER_ALLOCATION_HEAP
  tensor->quantization = tensorData[i].quantization;
  if (tensor->quantization.type == kTfLiteAffineQuantization) {
    TfLiteAffineQuantization const* quant = ((TfLiteAffineQuantization const*)(tensorData[i].quantization.params));
    tensor->params.scale = quant->scale->data[0];
    tensor->params.zero_point = quant->zero_point->data[0];
  }

}

static void init_tflite_eval_tensor(size_t i, TfLiteEvalTensor *tensor) {
  tensor->type = tensorData[i].type;

  tensor->dims = tensorData[i].dims;

#if defined(EI_CLASSIFIER_ALLOCATION_HEAP)
  auto allocation_type = tensorData[i].allocation_type;
  if(allocation_type == kTfLiteArenaRw) {
    uint8_t* start = (uint8_t*) ((uintptr_t)tensorData[i].data + (uintptr_t) tensor_arena);

    tensor->data.data =  start;
  }
  else {
    tensor->data.data = tensorData[i].data;
  }
#else
  tensor->data.data = tensorData[i].data;
#endif // EI_CLASSIFIER_ALLOCATION_HEAP
}

static void* overflow_buffers[EI_MAX_OVERFLOW_BUFFER_COUNT];
static size_t overflow_buffers_ix = 0;
static void * AllocatePersistentBuffer(struct TfLiteContext* ctx,
                                       size_t bytes) {
  void *ptr;
  if (current_location - bytes < tensor_boundary) {
    if (overflow_buffers_ix > EI_MAX_OVERFLOW_BUFFER_COUNT - 1) {
      ei_printf("ERR: Failed to allocate persistent buffer of size %d, does not fit in tensor arena and reached EI_MAX_OVERFLOW_BUFFER_COUNT\n",
        (int)bytes);
      return NULL;
    }

    // OK, this will look super weird, but.... we have CMSIS-NN buffers which
    // we cannot calculate beforehand easily.
    ptr = ei_calloc(bytes, 1);
    if (ptr == NULL) {
      ei_printf("ERR: Failed to allocate persistent buffer of size %d\n", (int)bytes);
      return NULL;
    }
    overflow_buffers[overflow_buffers_ix++] = ptr;
    return ptr;
  }

  current_location -= bytes;

  ptr = current_location;
  memset(ptr, 0, bytes);

  return ptr;
}
typedef struct {
  size_t bytes;
  void *ptr;
} scratch_buffer_t;
static scratch_buffer_t scratch_buffers[EI_MAX_SCRATCH_BUFFER_COUNT];
static size_t scratch_buffers_ix = 0;

static TfLiteStatus RequestScratchBufferInArena(struct TfLiteContext* ctx, size_t bytes,
                                                int* buffer_idx) {
  if (scratch_buffers_ix > EI_MAX_SCRATCH_BUFFER_COUNT - 1) {
    ei_printf("ERR: Failed to allocate scratch buffer of size %d, reached EI_MAX_SCRATCH_BUFFER_COUNT\n",
      (int)bytes);
    return kTfLiteError;
  }

  scratch_buffer_t b;
  b.bytes = bytes;

  b.ptr = AllocatePersistentBuffer(ctx, b.bytes);
  if (!b.ptr) {
    ei_printf("ERR: Failed to allocate scratch buffer of size %d\n",
      (int)bytes);
    return kTfLiteError;
  }

  scratch_buffers[scratch_buffers_ix] = b;
  *buffer_idx = scratch_buffers_ix;

  scratch_buffers_ix++;

  return kTfLiteOk;
}

static void* GetScratchBuffer(struct TfLiteContext* ctx, int buffer_idx) {
  if (buffer_idx > (int)scratch_buffers_ix) {
    return NULL;
  }
  return scratch_buffers[buffer_idx].ptr;
}

static const uint16_t TENSOR_IX_UNUSED = 0x7FFF;

static void ResetTensors() {
  for (size_t ix = 0; ix < MAX_TFL_TENSOR_COUNT; ix++) {
    tflTensors[ix].index = TENSOR_IX_UNUSED;
  }
  for (size_t ix = 0; ix < MAX_TFL_EVAL_COUNT; ix++) {
    tflEvalTensors[ix].index = TENSOR_IX_UNUSED;
  }
}

static TfLiteTensor* GetTensor(const struct TfLiteContext* context,
                               int tensor_idx) {

  for (size_t ix = 0; ix < MAX_TFL_TENSOR_COUNT; ix++) {
    // already used? OK!
    if (tflTensors[ix].index == tensor_idx) {
      return &tflTensors[ix].tensor;
    }
    // passed all the ones we've used, so end of the list?
    if (tflTensors[ix].index == TENSOR_IX_UNUSED) {
      // init the tensor
      init_tflite_tensor(tensor_idx, &tflTensors[ix].tensor);
      tflTensors[ix].index = tensor_idx;
      return &tflTensors[ix].tensor;
    }
  }

  ei_printf("ERR: GetTensor called beyond MAX_TFL_TENSOR_COUNT (%d)\n", MAX_TFL_TENSOR_COUNT);
  return nullptr;
}

static TfLiteEvalTensor* GetEvalTensor(const struct TfLiteContext* context,
                                       int tensor_idx) {

  for (size_t ix = 0; ix < MAX_TFL_EVAL_COUNT; ix++) {
    // already used? OK!
    if (tflEvalTensors[ix].index == tensor_idx) {
      return &tflEvalTensors[ix].tensor;
    }
    // passed all the ones we've used, so end of the list?
    if (tflEvalTensors[ix].index == TENSOR_IX_UNUSED) {
      // init the tensor
      init_tflite_eval_tensor(tensor_idx, &tflEvalTensors[ix].tensor);
      tflEvalTensors[ix].index = tensor_idx;
      return &tflEvalTensors[ix].tensor;
    }
  }

  ei_printf("ERR: GetTensor called beyond MAX_TFL_EVAL_COUNT (%d)\n", (int)MAX_TFL_EVAL_COUNT);
  return nullptr;
}

} // namespace

TfLiteStatus trained_model_init( void*(*alloc_fnc)(size_t,size_t) ) {
#ifdef EI_CLASSIFIER_ALLOCATION_HEAP
  tensor_arena = (uint8_t*) alloc_fnc(16, kTensorArenaSize);
  if (!tensor_arena) {
    ei_printf("ERR: failed to allocate tensor arena\n");
    return kTfLiteError;
  }
#else
  memset(tensor_arena, 0, kTensorArenaSize);
#endif
  tensor_boundary = tensor_arena;
  current_location = tensor_arena + kTensorArenaSize;
  ctx.AllocatePersistentBuffer = &AllocatePersistentBuffer;
  ctx.RequestScratchBufferInArena = &RequestScratchBufferInArena;
  ctx.GetScratchBuffer = &GetScratchBuffer;
  ctx.GetTensor = &GetTensor;
  ctx.GetEvalTensor = &GetEvalTensor;
  ctx.tensors_size = 23;
  for (size_t i = 0; i < 23; ++i) {
    TfLiteTensor tensor;
    init_tflite_tensor(i, &tensor);
    if (tensor.allocation_type == kTfLiteArenaRw) {
      auto data_end_ptr = (uint8_t*)tensor.data.data + tensorData[i].bytes;
      if (data_end_ptr > tensor_boundary) {
        tensor_boundary = data_end_ptr;
      }
    }
  }
  if (tensor_boundary > current_location /* end of arena size */) {
    ei_printf("ERR: tensor arena is too small, does not fit model - even without scratch buffers\n");
    return kTfLiteError;
  }
  registrations[OP_RESHAPE] = Register_RESHAPE();
  registrations[OP_CONV_2D] = Register_CONV_2D();
  registrations[OP_MAX_POOL_2D] = Register_MAX_POOL_2D();
  registrations[OP_FULLY_CONNECTED] = Register_FULLY_CONNECTED();
  registrations[OP_SOFTMAX] = Register_SOFTMAX();

  for (size_t i = 0; i < 11; ++i) {
    tflNodes[i].inputs = nodeData[i].inputs;
    tflNodes[i].outputs = nodeData[i].outputs;
    tflNodes[i].builtin_data = nodeData[i].builtin_data;
tflNodes[i].custom_initial_data = nullptr;
      tflNodes[i].custom_initial_data_size = 0;
if (registrations[nodeData[i].used_op_index].init) {
      tflNodes[i].user_data = registrations[nodeData[i].used_op_index].init(&ctx, (const char*)tflNodes[i].builtin_data, 0);
    }
  }
  for (size_t i = 0; i < 11; ++i) {
    if (registrations[nodeData[i].used_op_index].prepare) {
      ResetTensors();

      TfLiteStatus status = registrations[nodeData[i].used_op_index].prepare(&ctx, &tflNodes[i]);
      if (status != kTfLiteOk) {
        return status;
      }
    }
  }
  return kTfLiteOk;
}

static const int inTensorIndices[] = {
  0, 
};
TfLiteStatus trained_model_input(int index, TfLiteTensor *tensor) {
  init_tflite_tensor(inTensorIndices[index], tensor);
  return kTfLiteOk;
}

static const int outTensorIndices[] = {
  22, 
};
TfLiteStatus trained_model_output(int index, TfLiteTensor *tensor) {
  init_tflite_tensor(outTensorIndices[index], tensor);
  return kTfLiteOk;
}

TfLiteStatus trained_model_invoke() {
  for (size_t i = 0; i < 11; ++i) {
    ResetTensors();

    TfLiteStatus status = registrations[nodeData[i].used_op_index].invoke(&ctx, &tflNodes[i]);

#if EI_CLASSIFIER_PRINT_STATE
    ei_printf("layer %lu\n", i);
    ei_printf("    inputs:\n");
    for (size_t ix = 0; ix < tflNodes[i].inputs->size; ix++) {
      auto d = tensorData[tflNodes[i].inputs->data[ix]];

      size_t data_ptr = (size_t)d.data;

      if (d.allocation_type == kTfLiteArenaRw) {
        data_ptr = (size_t)tensor_arena + data_ptr;
      }

      if (d.type == TfLiteType::kTfLiteInt8) {
        int8_t* data = (int8_t*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes; jx++) {
          ei_printf("%d ", data[jx]);
        }
      }
      else {
        float* data = (float*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes / 4; jx++) {
          ei_printf("%f ", data[jx]);
        }
      }
      ei_printf("\n");
    }
    ei_printf("\n");

    ei_printf("    outputs:\n");
    for (size_t ix = 0; ix < tflNodes[i].outputs->size; ix++) {
      auto d = tensorData[tflNodes[i].outputs->data[ix]];

      size_t data_ptr = (size_t)d.data;

      if (d.allocation_type == kTfLiteArenaRw) {
        data_ptr = (size_t)tensor_arena + data_ptr;
      }

      if (d.type == TfLiteType::kTfLiteInt8) {
        int8_t* data = (int8_t*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes; jx++) {
          ei_printf("%d ", data[jx]);
        }
      }
      else {
        float* data = (float*)data_ptr;
        ei_printf("        %lu (%zu bytes, ptr=%p, alloc_type=%d, type=%d): ", ix, d.bytes, data, (int)d.allocation_type, (int)d.type);
        for (size_t jx = 0; jx < d.bytes / 4; jx++) {
          ei_printf("%f ", data[jx]);
        }
      }
      ei_printf("\n");
    }
    ei_printf("\n");
#endif // EI_CLASSIFIER_PRINT_STATE

    if (status != kTfLiteOk) {
      return status;
    }
  }
  return kTfLiteOk;
}

TfLiteStatus trained_model_reset( void (*free_fnc)(void* ptr) ) {
#ifdef EI_CLASSIFIER_ALLOCATION_HEAP
  free_fnc(tensor_arena);
#endif

  // scratch buffers are allocated within the arena, so just reset the counter so memory can be reused
  scratch_buffers_ix = 0;

  // overflow buffers are on the heap, so free them first
  for (size_t ix = 0; ix < overflow_buffers_ix; ix++) {
    ei_free(overflow_buffers[ix]);
  }
  overflow_buffers_ix = 0;
  return kTfLiteOk;
}
